/*
	Black Jack for CASIO fx-9860G
	wb_
*/

#define FALSE	0
#define TRUE	1

#define PERSON_DEALER	0
#define PERSON_PLAYER	1

#define DECKS	2

#define RANK_FIRST	0
#define RANK_TWO	(RANK_FIRST + 0)
#define RANK_THREE	(RANK_FIRST + 1)
#define RANK_FOUR	(RANK_FIRST + 2)
#define RANK_FIVE	(RANK_FIRST + 3)
#define RANK_SIX	(RANK_FIRST + 4)
#define RANK_SEVEN	(RANK_FIRST + 5)
#define RANK_EIGHT	(RANK_FIRST + 6)
#define RANK_NINE	(RANK_FIRST + 7)
#define RANK_TEN	(RANK_FIRST + 8)
#define RANK_JACK	(RANK_FIRST + 9)
#define RANK_QUEEN	(RANK_FIRST + 10)
#define RANK_KING	(RANK_FIRST + 11)
#define RANK_ACE	(RANK_FIRST + 12)
#define RANK_LAST	(RANK_FIRST + 12)

#define SUIT_FIRST	0
#define SUIT_SPADE	(SUIT_FIRST + 0)
#define SUIT_HEART	(SUIT_FIRST + 1)
#define SUIT_DIAMOND	(SUIT_FIRST + 2)
#define SUIT_CLUB	(SUIT_FIRST + 3)
#define SUIT_LAST	(SUIT_FIRST + 3)

#define PUTCARD_PUT	0
#define PUTCARD_TAIL	1
#define PUTCARD_UNPUT	2

#define PLAY_HIT	0
#define PLAY_STAY	1
#define PLAY_DOUBLE	2
#define PLAY_SPLIT	3
#define PLAY_SURRENDER	4
#define PLAY_INSURANCE	5
#define PLAY_NO		6
#define PLAY_PLAY	7
#define PLAY_DEC	8
#define PLAY_INC	9
#define PLAY_INIT	10
#define PLAY_YES	11
#define PLAY_HIT_MASK	(1U << PLAY_HIT)
#define PLAY_STAY_MASK	(1U << PLAY_STAY)
#define PLAY_DOUBLE_MASK	(1U << PLAY_DOUBLE)
#define PLAY_SPLIT_MASK	(1U << PLAY_SPLIT)
#define PLAY_SURRENDER_MASK	(1U << PLAY_SURRENDER)
#define PLAY_INSURANCE_MASK	(1U << PLAY_INSURANCE)
#define PLAY_NO_MASK	(1U << PLAY_NO)
#define PLAY_PLAY_MASK	(1U << PLAY_PLAY)
#define PLAY_DEC_MASK	(1U << PLAY_DEC)
#define PLAY_INC_MASK	(1U << PLAY_INC)
#define PLAY_INIT_MASK	(1U << PLAY_INIT)
#define PLAY_YES_MASK	(1U << PLAY_YES)

#define GAME_WIN	0
#define GAME_LOSE	1
#define GAME_TIE	2

#define MAX(x, y)	((x) > (y) ? (x): (y))
#define MIN(x, y)	((x) < (y) ? (x): (y))
#define SUIT(card)	((card) >> 4)
#define RANK(card)	((card) & 0x0f)
#define MAKE_CARD(suit, rank)	(((suit) << 4) | (rank))

/*
	Copyright 2010 maruhiro
	All rights reserved. 

	Redistribution and use in source and binary forms, 
	with or without modification, are permitted provided that 
	the following conditions are met: 

	 1. Redistributions of source code must retain the above copyright notice, 
	    this list of conditions and the following disclaimer. 

	 2. Redistributions in binary form must reproduce the above copyright notice, 
	    this list of conditions and the following disclaimer in the documentation 
	    and/or other materials provided with the distribution. 

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
	FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
	THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* eof */